open Stdlib.Base
open Stdlib.Comm
open Datatypes
open NPeano
open NatTools
open BsmlNat.Primitives

module Processors = BsmlProperties.Make(BsmlNat.Primitives)
open Processors

let par_print_nat = 
  parprint (fun n ->print_string (string_of_int (int_of_nat n)))

let print_nat = 
  fun n -> bsml_print print_string 0 ( replicate (string_of_int (int_of_nat n)))

let par_print_string = parprint (fun s ->print_string s)

let print_str = fun n -> bsml_print print_string 0 ( replicate  n)

let test_put () =  put (mkpar (fun i -> (fun j -> i)))


let sync () = put(replicate(fun i->()))

let _ = 
  begin
    print_str "\nlastProcessor :";
    print_nat  lastProcessor;
    (* print_str "\nproc_max :"; *)
    (* print_nat  processor_max; *)
    (* print_str "\nprocessor0 :"; *)
    (* print_nat  processor0; *)
    sync();
    Bsml.start_timing();
    test_put(); 
    Bsml.stop_timing();
    sync();
    ignore(bsml_print print_float 0 (fold_direct max (Bsml.get_cost())))      
  end
