open Datatypes
open List0
open Peano
open NPeano
open NatTools
open Tools

module Make (B : BsmlSpec.PRIMITIVES) :
 sig
  val firstProcessor : B.processor
  val lastProcessor : B.processor
  val processorOfNatMod : nat -> B.processor
  val processors : B.processor list
 end = 
 struct 
   (** val firstProcessor : BsmlPrimitives.processor **) 
   let firstProcessor = O


  (** val lastProcessor : BsmlPrimitives.processor **)
   let lastProcessor = 
     minus B.bsp_p (S O)

  (** val processors : BsmlPrimitives.processor list **)
   let processors = map nat_of_int (from_to 0 (int_of_nat lastProcessor))

  (** val processorOfNatMod : nat -> BsmlPrimitives.processor **)
  let processorOfNatMod n = modulo n B.bsp_p
   (** val firstProcessor : BsmlPrimitives.processor **) 
   let processorEqDec (p1 )( p2 ) =  (p1 = p2)

   let processor_beq (p1 )( p2 ) =  (p1 = p2)


 end

