Tactic Notation  "copy" hyp(h) "as" ident(h1) :=
    let t:= type of h  in 
      assert (h1 :t ) by assumption.

Tactic Notation  "copy" hyp(h) "into" ident(h1) :=
  let H := fresh h1 in 
    let t:= type of h  in 
      assert (H :t ) by assumption.

Tactic Notation  "duplicate" ident(h) :=
  copy h into h .


Goal forall H:nat, nat.
  intro.
  duplicate H.
  copy H as H1.
  copy H into H1.
  auto.
Qed.  

(* *)
