Require Import Arith.
Require Import Omega. 
Require Import Program.
(* Require Import List. *)
(* Require Classes.EquivDec. *)
(* Require Import LIFO.List.Misc. *)
(* Require Import LIFO.List.InSig. *)
(* Require Import LIFO.List.Map. *)
(* Require Import LIFO.List.SeqNat. *)
(* Require Import LIFO.List.Mem. *)
(* Require Import LIFO.List.Assoc. *)
(* Require Import CertifiedBSML.Support.Option. *)
Require CertifiedBSML.Primitives.Specification.
Require CertifiedBSML.Primitives.Properties.
Require CertifiedBSML.Support.ParSig.
Require CertifiedBSML.StandardLibrary.Base.
Require CertifiedBSML.StandardLibrary.Comm.

Module bench 
  (Bsml : Primitives.Specification.PRIMITIVES)
  (Props: Primitives.Properties.TYPE Bsml)
  (ParSig: Support.ParSig.TYPE Bsml Props)
  (Base: StandardLibrary.Base.TYPE Bsml Props ParSig)
  (Comm: StandardLibrary.Comm.TYPE Bsml  Props ParSig Base).

Import Bsml Base Comm.


Program Definition shift := Comm.shift_left.
Fixpoint testing_arith_nat i n :=
  match i with
    | 0 => n
    | S n' => let n'' := n + n' *i 
      in testing_arith_nat n' n''
  end.

(* Time Eval vm_compute  in testing_arith_nat 100 100. *)

End bench.

